From 3d95af82cfe38d714e641ab6e0c6e9262084102e Mon Sep 17 00:00:00 2001
From: Raul Tambre <raul.tambre@clevon.com>
Date: Sun, 29 May 2022 11:48:22 +0300
Subject: [PATCH] Revert "rtph265depay: update codec_data in caps regardless of
 format"

This reverts commit 95f6c31c21269843419bcc61d1eb6e5708305c55.
---
 .../gst/rtp/gstrtph265depay.c                 | 31 +++++++++++++++++--
 1 file changed, 29 insertions(+), 2 deletions(-)

--- a/subprojects/gst-plugins-good/gst/rtp/gstrtph265depay.c
+++ b/subprojects/gst-plugins-good/gst/rtp/gstrtph265depay.c
@@ -391,7 +391,7 @@ gst_rtp_h265_depay_set_output_caps (GstR
 static gboolean
 gst_rtp_h265_set_src_caps (GstRtpH265Depay * rtph265depay)
 {
-  gboolean res;
+  gboolean res, update_caps;
   GstCaps *old_caps;
   GstCaps *srccaps;
   GstPad *srcpad;
@@ -600,9 +600,36 @@ gst_rtp_h265_set_src_caps (GstRtpH265Dep
   }
 
   srcpad = GST_RTP_BASE_DEPAYLOAD_SRCPAD (rtph265depay);
+
   old_caps = gst_pad_get_current_caps (srcpad);
+  if (old_caps != NULL) {
+
+    /* Only update the caps if they are not equal. For
+     * AVC we don't update caps if only the codec_data
+     * changes. This is the same behaviour as in h264parse
+     * and gstrtph264depay
+     */
+    if (rtph265depay->byte_stream) {
+      update_caps = !gst_caps_is_equal (srccaps, old_caps);
+    } else {
+      GstCaps *tmp_caps = gst_caps_copy (srccaps);
+      GstStructure *old_s, *tmp_s;
+
+      old_s = gst_caps_get_structure (old_caps, 0);
+      tmp_s = gst_caps_get_structure (tmp_caps, 0);
+      if (gst_structure_has_field (old_s, "codec_data"))
+        gst_structure_set_value (tmp_s, "codec_data",
+            gst_structure_get_value (old_s, "codec_data"));
+
+      update_caps = !gst_caps_is_equal (old_caps, tmp_caps);
+      gst_caps_unref (tmp_caps);
+    }
+    gst_caps_unref (old_caps);
+  } else {
+    update_caps = TRUE;
+  }
 
-  if (old_caps == NULL || !gst_caps_is_equal (srccaps, old_caps)) {
+  if (update_caps) {
     res = gst_rtp_h265_depay_set_output_caps (rtph265depay, srccaps);
   } else {
     res = TRUE;
